export async function buildPeer() {
    return new Peer();
}

export async function buildPeerCustomHost(id, host) {
    return new Peer(id , {host: host, secure: true});
}

export async function GetMetadata(conn) {
    return conn.metadata;
}

export async function GetBufferedAmount(conn) {
    return conn.dataChannel.bufferedAmount;
}
export async function RegisterEvent(peerElement, event, dotNetObject, callbackMethod, nbParams) {
    switch (nbParams) {
        case 0:
            peerElement.on(event, async () => await dotNetObject.invokeMethodAsync(callbackMethod));
            break;
        case 1:
            peerElement.on(event, async (p1) => await dotNetObject.invokeMethodAsync(callbackMethod, p1));
            break;
        case 2:
            peerElement.on(event, async (p1, p2) => await dotNetObject.invokeMethodAsync(callbackMethod, p1, p2));
            break;
        case 3:
            peerElement.on(event, async (p1, p2, p3) => await dotNetObject.invokeMethodAsync(callbackMethod, p1, p2, p3));
            break;
        case 4:
            peerElement.on(event, async (p1, p2, p3, p4) => await dotNetObject.invokeMethodAsync(callbackMethod, p1, p2, p3, p4));
            break;
        default:
            throw new Error('Max 4 parameters supported');
    }
}

export async function RegisterEventWithRefParam(peerElement, event, dotNetObject, callbackMethod) {
    peerElement.on(event, async (p1) => {
        let p1Container = DotNet.createJSObjectReference(p1);
        await dotNetObject.invokeMethodAsync(callbackMethod, p1Container);
    });
}

